package com.yspay.demo.https;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.URL;
import java.util.Map;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;

import com.alibaba.fastjson.JSON;

public class Https {


    public static String httpsSend(String urlNotify, int connectTimeout, int readTimeout) throws Exception {
        return httpsSend(urlNotify, null, connectTimeout, readTimeout);
    }

    /**
     * [HTTPS]
     * 
     * @param urlNotify
     * @param param
     * @return
     */
    public static String httpsSend(String urlNotify, Map<String, String> param, int connectTimeout, int readTimeout) throws Exception {
        InputStream inputStream = null;
        InputStreamReader inputStreamReader = null;
        BufferedReader bufferedReader = null;
        OutputStream os = null;
        HttpsURLConnection conn = null;
        try {
            TrustManager[] tm = { new YzyueX509TrustManager() };
            SSLContext sslContext = SSLContext.getInstance("TLS");
            sslContext.init(null, tm, null);
            SSLSocketFactory ssf = sslContext.getSocketFactory();

            URL url = new URL(urlNotify);
            conn = (HttpsURLConnection) url.openConnection();
            conn.setHostnameVerifier(new Https().new TrustAnyHostnameVerifier());
            conn.setSSLSocketFactory(ssf);
            conn.setDoOutput(true);
            conn.setDoInput(true);
            conn.setUseCaches(false);
            conn.setConnectTimeout(connectTimeout);
            conn.setReadTimeout(readTimeout);
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Content-Type", "application/json;charset=utf-8");
            conn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.0; Windows NT; DigExt)");

            StringBuffer sb = new StringBuffer();
            sb.append(JSON.toJSON(param));
            String message = sb.toString();
            System.out.println("请求地址[" + urlNotify + "],请求数据:\r\n" + message);

            os = conn.getOutputStream();
            os.write(message.getBytes("UTF-8"));
            os.close();

            // 将返回的输入流转换成字符串
            inputStream = conn.getInputStream();
            inputStreamReader = new InputStreamReader(inputStream, "utf-8");
            bufferedReader = new BufferedReader(inputStreamReader);
            StringBuffer buffer = new StringBuffer();
            String str = null;
            while ((str = bufferedReader.readLine()) != null) {
                buffer.append(str);
            }
            String result = buffer.toString();
            System.out.println("响应数据:\r\n" + result);
            return result;
        } finally {
            if (bufferedReader != null) {
                bufferedReader.close();
            }
            if (inputStreamReader != null) {
                inputStreamReader.close();
            }
            if (inputStream != null) {
                inputStream.close();
            }
            if (os != null) {
                os.close();
            }
            if (conn != null) {
                conn.disconnect();
            }
        }
    }

    public class TrustAnyHostnameVerifier implements HostnameVerifier {
        public boolean verify(String hostname, SSLSession session) {
            return true;
        }
    }
}
