package com.yspay.demo.service;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import org.junit.Test;

import com.yspay.demo.DesUtil;
import com.yspay.demo.GenerateSignUtil;
import com.yspay.demo.HttpClientUtil;

import net.sf.json.JSONObject;

public class Demo {
	private static String URL = "http://orgmerc.ysepay.com:8880/saas/org";

	// 进件接口
	@Test
	public void applyTest() throws Exception {

		File privateKeyFile = new File("D:\\Users\\huapf\\tms\\demo\\src\\java\\resources\\conf\\yulong_666.pfx");
		String privateKeyPassword = "123456";
		Map<String, String> map = new HashMap<String, String>();
		map.put("businessLicence", "某某科技有限公司");// 营业执照全称
		map.put("userShortName", "某某");// 商户简称（小票）
		map.put("businessLicenceNo", "2342424fsdf");// 营业执照号码
		map.put("businessLicenceSdate", "20080803");// 营业执照开始日期
		map.put("businessLicenceEdate", "43931221");// 营业执照结束日期
		map.put("registeredAddress", "中国广东深圳");// 注册地址
		map.put("businessAddress", "深圳");// 营业地址
		map.put("legalPersonName", "小李");// 法人姓名
		map.put("legalPersonId", "123456987523659485");// 法人身份证号
		map.put("legalPersonIdSdate", "15221222");// 法人身份证开始日期
		map.put("legalPersonIdEdate", "15231222");// 法人身份证到期日期
		map.put("legalPersonPhone", "12365984521");// 法人电话
		map.put("unincorporatedName", "xiaoming");// 非法人姓名
		map.put("unincorporatedId", "123456987523659485");// 非法人身份证号码
		map.put("balanceAccCardno", "34242");// 结算账户卡号
		map.put("balanceAccName", "小李");// 结算账户户名
		map.put("openAccProvince", "天津市");// 开户行省
		map.put("openAccCity", "天津市");// 开户行市
		map.put("openAccArea", "");// 开户行区
		map.put("bankName", "北京银行");// 开户行行别名称
		map.put("bankType", "3131000");// 开户行行别编号
		map.put("openAccBanktype", "313110010053");// 开户行编号（支行）
		map.put("openAccBankname", "北京银行股份有限公司天津开发区支行");// 开户行名称（支行）
		map.put("contactsName", "小伟");// 联系人姓名
		map.put("contactsPhone", "12345648965");// 联系人电话
		map.put("contactsEmail", "11@qq.com");// 联系人邮箱
		map.put("wechatSignRate", "33");// 微信签约费率
		map.put("wechatSignMin", "1111");// 微信签约费率封底
		map.put("wechatSignMax", "1111");// 微信签约费率封顶
		map.put("alipaySignMin", "1111");// 支付宝签约费率封底
		map.put("alipaySignMax", "1111");// 支付宝签约费率封顶
		map.put("alipaySignRate", "33");// 支付宝签约费率
		map.put("userType", "0");// 商户模式（0-一般商户;1-企业商户;3-小薇商户
		map.put("remark", "");// 备注
		map.put("lowestStlAmt", "3222");// 结算起始金额，单位
		map.put("bankMobile", "12345648965");// 银行预留手机号
		map.put("actualManager", "李总");// 实际控制人
		map.put("certType", "00");// 证件类型 身份证 00（只支持00）
		map.put("mercLvl", "2");// 商户级别
		map.put("mercUpId", "324242");// 总店商户号
		map.put("contactsAddr", "北京朝阳区");// 联系人通讯地址
		map.put("balanceAccType", "11");// 结算卡类型
		map.put("reportMerchantName", "");// 报备名称

		JSONObject j = JSONObject.fromObject(map);
		String data = j.toString();
		System.out.println("data==" + data);
		String key = "A81F41DE7406CC1566579A751D93CA7A";
		String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
		System.out.println(creData);
		String sign = "";
		JSONObject json = null;
		Map<String, String> params = new HashMap<String, String>();
		try {

			params.put("ver", "1.0");
			params.put("msgCode", "Merchant");
			params.put("method", "addMerchant");
			params.put("src", "ORG20190724181388");
			params.put("signType", "RSA");
			params.put("charset", "UTF-8");
			params.put("data", creData);

			sign = GenerateSignUtil.generateSign(params, privateKeyFile, privateKeyPassword);
			System.out.println("sign=" + sign);
			params.put("signValue", sign);
			params.put("reqFlowId", "1111123");// reqflowid
			json = JSONObject.fromObject(params);

		} catch (Exception e) {
			e.printStackTrace();
		}
		String url = URL + "/addMerchant";
		String result = HttpClientUtil.sendJson(url, json);
		System.out.println(result);
	}
}
