package com.yspay.demo.service;

import com.alibaba.fastjson.JSON;
import com.yspay.demo.DesUtil;
import com.yspay.demo.GenerateSignUtil;
import com.yspay.demo.HttpClientUtil;
import hikefa.core.exception.BizException;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.junit.Test;

import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;

public class HtkDemo {
	//private static String url =  "http://10.211.61.214:8083/mkagentcon/merchants/autoTerReview";
	private static String url =  "http://console-gateway-fat.yspos-fat.com/mkagentcon/merchants/autoTerReview";

	// 进件接口
	@Test
	public void applyTest() throws Exception {
//		String id="202111020011713";
//		try {
//			System.out.println(id+"------服务商通过发送异步通知----");
//			Map param = new HashMap();
//			param.put("type", "826");
//			param.put("id", id);
//			param.put("status", "05");
//			String result = sendGet(url, param,null);
//			System.out.println(id+"------服务商通过发送异步通知结果----" + result);
//		} catch (Exception e) {
//			System.out.println(id+"服务商通过发送异步通知出错"+e.getMessage());
//		}
		Map<String, Object> feeMap = new HashMap<String, Object>();
		utilSegmentFeeForCreditDebit(feeMap, "0.3", "0", "100", "0", "1000.01");
		utilSegmentFeeForCreditDebit(feeMap, "0.59", "0", "2000", "1000.01", "999999.99");
		System.out.println(JSON.toJSONString(feeMap));
	}

	public static void utilSegmentFeeForCreditDebit(Map<String, Object> feeMap, String percentStr, String lowValueStr, String highValueStr, String minAmt, String maxAmt) {
		List<Map<String, Object>> feeSegmentRateList = (List<Map<String, Object>>)feeMap.get("feeSegmentRateList");
		if (feeSegmentRateList == null) {
			feeSegmentRateList = new ArrayList<Map<String, Object>>();
		}
		BigDecimal maxAmtBigDec = new BigDecimal(maxAmt).setScale(2, RoundingMode.FLOOR);
		BigDecimal minAmtBigDec = new BigDecimal(minAmt).setScale(2, RoundingMode.FLOOR);
		BigDecimal rate = new BigDecimal(percentStr);
		BigDecimal rateRadio = rate.divide(new BigDecimal("100"),6, RoundingMode.FLOOR);
		Map<String, Object> feeSementMap1 = new HashMap<String, Object>();
		//两者都没填的话走费率
		if ((StringUtils.isBlank(lowValueStr) && StringUtils.isBlank(highValueStr)) || rateRadio.compareTo(BigDecimal.ZERO)==0) {
			feeSementMap1.put("amountStart", minAmtBigDec.doubleValue());
			feeSementMap1.put("amountEnd", maxAmtBigDec.doubleValue());
			feeSementMap1.put("feeRate", rate.doubleValue());
			feeSegmentRateList.add(feeSementMap1);
		} else {
			Map<String, Object> feeSementMap3Temp = null;
			BigDecimal divideDecAdd = null;
			if (StringUtils.isNotBlank(lowValueStr)) {
				BigDecimal lowValueDec = new BigDecimal(lowValueStr).divide(new BigDecimal("100"), 2, RoundingMode.FLOOR);
				BigDecimal divideDec = lowValueDec.divide(rateRadio, 2, RoundingMode.FLOOR);
				if (divideDec.compareTo(minAmtBigDec) > 0) {
					divideDecAdd = divideDec.add(new BigDecimal("0.01"));
					Map<String, Object> feeSementMap2 = new HashMap<String, Object>();
					feeSementMap2.put("amountStart", minAmtBigDec.doubleValue());
					feeSementMap2.put("amountEnd", divideDecAdd.compareTo(maxAmtBigDec) < 0 ? divideDecAdd.doubleValue() : maxAmtBigDec.doubleValue());
					feeSementMap2.put("fee", lowValueDec.doubleValue());
					feeSegmentRateList.add(feeSementMap2);
				}
				if (divideDec.compareTo(maxAmtBigDec) < 0) {
					feeSementMap3Temp = new HashMap();
					feeSementMap3Temp.put("amountStart", divideDecAdd == null ? minAmtBigDec.doubleValue() : divideDecAdd.doubleValue());
					feeSementMap3Temp.put("amountEnd", maxAmtBigDec.doubleValue());
					feeSementMap3Temp.put("feeRate", rate.doubleValue());
				}
			}
			if (StringUtils.isNotBlank(highValueStr)) {
				BigDecimal highValueDec = new BigDecimal(highValueStr).divide(new BigDecimal("100"), 2, RoundingMode.FLOOR);
				if (highValueDec.compareTo(new BigDecimal("0")) != 0) {
					BigDecimal divideHighDec = highValueDec.divide(rateRadio, 2, RoundingMode.FLOOR);
					BigDecimal divideHighDecAdd =  divideHighDec.add(new BigDecimal(0.01));
					if (divideHighDecAdd.compareTo(maxAmtBigDec) < 0 && divideHighDecAdd.compareTo(minAmtBigDec) > 0) {
						if (feeSementMap3Temp != null) {
							feeSementMap3Temp.put("amountEnd", divideHighDecAdd.doubleValue());
						}
						//说明只填写了封顶
						if (StringUtils.isBlank(lowValueStr)) {
							Map<String, Object> feeSementMap5 = new HashMap<String, Object>();
							feeSementMap5.put("amountStart", minAmtBigDec.doubleValue());
							feeSementMap5.put("amountEnd", divideHighDecAdd.doubleValue());
							feeSementMap5.put("feeRate", rate.doubleValue());
							feeSegmentRateList.add(feeSementMap5);
						}
						if (divideHighDecAdd.compareTo(maxAmtBigDec) < 0) {
							Map<String, Object> feeSementMap4 = new HashMap<String, Object>();
							feeSementMap4.put("amountStart", divideHighDecAdd.doubleValue());
							feeSementMap4.put("amountEnd", maxAmtBigDec.doubleValue());
							feeSementMap4.put("fee", highValueDec.doubleValue());
							feeSegmentRateList.add(feeSementMap4);
						}
					}
				}
			}
			if (feeSementMap3Temp != null) {
				feeSegmentRateList.add(feeSementMap3Temp);
			}
		}
		feeMap.put("feeSegmentRateList", feeSegmentRateList);
	}


	public static  String sendGet(String url, Map<String, String> getMap, Map<String, String> header) {
		String body = null;
		int statusCode = 0;
		CloseableHttpClient client = null;
		CloseableHttpResponse response = null;
		HttpGet get = null;
		try {
			long startTime = 0L;
			long endTime = 0L;
			URIBuilder uriBuilder = new URIBuilder(url);
			if (getMap != null) {
				Set<Map.Entry<String, String>> entries = getMap.entrySet();
				for (Map.Entry<String, String> entry : entries) {
					uriBuilder.addParameter(entry.getKey(), entry.getValue());
				}
			}
			get = new HttpGet(uriBuilder.build());
			if (header != null) {
				for (Map.Entry<String, String> stringStringEntry : header.entrySet()) {
					get.setHeader(stringStringEntry.getKey(), stringStringEntry.getValue());
				}
			}
			//开始时间
			startTime = System.currentTimeMillis();
			client = HttpClients.createDefault();
			response = client.execute(get);
			//结束时间
			endTime = System.currentTimeMillis();
			statusCode = response.getStatusLine().getStatusCode();
			if(statusCode == org.springframework.http.HttpStatus.OK.value()){
				body= EntityUtils.toString(response.getEntity());
			}else{
				throw new BizException("调用失败,状态码HttpStatusCode="+statusCode);
			}
		}catch(Throwable e){
			throw new BizException("通讯连接异常,状态码HttpStatusCode="+statusCode);
		}finally{
			try{
				if(response != null){
					response.close();
				}
				if(client != null){
					client.close();
				}
				if (get != null) {
					get.releaseConnection();
				}
			} catch (IOException e) {
			}
		}
		return body;
	}

}
