package com.yspay.demo.service;

import com.alibaba.fastjson.JSONArray;
import com.yspay.demo.DesUtil;
import com.yspay.demo.GenerateSignUtil;
import com.yspay.demo.HttpClientUtil;
import net.sf.json.JSONObject;
import org.junit.Test;

import java.io.File;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName 扫码商户信息变更 基本信息变更&账户信息变更
 * CreateDate 2021/9/24 10:58
 */
public class MercInfoModifyDemo {

    //	private static String URL = "https://ouser.ysepay.com:6443/saas/org";   //正式环境
    //  private static String URL = "http://orgmerc.ysepay.com:8880/saas/org"; //测试环境
    //	private static String URL = "https://bcs.ysepay.com/saas/org";  //灰度环境
    private static String URL = "http://10.211.61.36:7100/saas/org";  //

    // 商户基本信息变更
    @Test
    public void changeMerInfoTest() throws Exception {

        File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
        String privateKeyPassword = "123456";
        Map<String, String> map = new HashMap<String, String>();
        map.put("mercid", "826440357229AV8");// 商户号
        map.put("businessLicence", "测试是是是是是是");// 营业执照全称
        map.put("userShortName", "测试是是是是是是");// 商户简称
        map.put("businessLicenceNo", "44030069119");// 营业执照号码
        map.put("businessLicenceSdate", "20080803");// 营业执照开始日期
        map.put("businessLicenceEdate", "29991221");// 营业执照结束日期
        map.put("registeredAddress", "深圳");// 注册地址
        map.put("businessAddress", "深圳");// 营业地址
        map.put("legalPersonName", "吴广义");// 法人姓名
        map.put("legalPersonId", "110115198702028588");// 法人身份证号
        map.put("legalPersonIdSdate", "20101111");// 法人身份证开始日期
        map.put("legalPersonIdEdate", "29991111");// 法人身份证到期日期
        map.put("legalPersonPhone", "13928485720");// 法人电话
        map.put("contactsName", "小伟");// 联系人姓名
        map.put("contactsPhone", "13928485720");// 联系人电话
        map.put("contactsEmail", "cenjf@eptok.com");// 联系人邮箱


        JSONObject j = JSONObject.fromObject(map);
        String data = j.toString();
        System.out.println("data==" + data);
        String key = "A81F41DE7406CC1566579A751D93CA7A";
        String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
        System.out.println(creData);
        String sign = "";
        JSONObject json = null;
        Map<String, String> params = new HashMap<String, String>();
        try {

            params.put("ver", "1.0");
            params.put("msgCode", "Merchant");
            params.put("method", "changeMerInfo");
            params.put("src", "ORG20191114174409");
            params.put("signType", "RSA");
            params.put("charset", "UTF-8");
            params.put("data", creData);

            sign = GenerateSignUtil.generateSign(params, privateKeyFile,
                    privateKeyPassword);
//            params.put("reqFlowId", String.valueOf(new Date().getTime()));
            System.out.println("sign=" + sign);
            params.put("signValue", sign);
            json = JSONObject.fromObject(params);

        } catch (Exception e) {
            e.printStackTrace();
        }
        String url = URL + "/changeMerInfo";
        String result = HttpClientUtil.sendJson(url, json);
        //	String result = Https.httpsSend(url, params, 10000, 10000);
        System.out.println(result);
    }

    // 商户账户信息变更
    @Test
    public void changeMerAccInfoTest() throws Exception {

        File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
        String privateKeyPassword = "123456";
        Map<String, String> map = new HashMap<String, String>();
        map.put("mercid", "826440357229AV8");// 商户号

        map.put("balanceAccCardno", "6227000066510036662");// 结算账户卡号
        map.put("balanceAccName", "吴广义");// 结算账户户名
        map.put("openAccProvince", "北京市");// 开户行省
        map.put("openAccCity", "北京市");// 开户行市
        map.put("openAccArea", "东城区");// 开户行区
        map.put("bankName", "建设银行");// 开户行别名名称
        map.put("bankType", "1051000");// 开户行别名编号
        map.put("openAccBanktype", "105100001028");// 开户行编号（支行）
        map.put("openAccBankname", "中国建设银行北京市分行前门支行营业部");// 开户行名称（支行）
        map.put("bankMobile", "13322234567");// 银行预留手机号


        JSONObject j = JSONObject.fromObject(map);
        String data = j.toString();
        System.out.println("data==" + data);
        String key = "A81F41DE7406CC1566579A751D93CA7A";
        String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
        System.out.println(creData);
        String sign = "";
        JSONObject json = null;
        Map<String, String> params = new HashMap<String, String>();
        try {

            params.put("ver", "1.0");
            params.put("msgCode", "Merchant");
            params.put("method", "changeMerInfo");
            params.put("src", "ORG20191114174409");
            params.put("signType", "RSA");
            params.put("charset", "UTF-8");
            params.put("data", creData);

            sign = GenerateSignUtil.generateSign(params, privateKeyFile,
                    privateKeyPassword);
//            params.put("reqFlowId", String.valueOf(new Date().getTime()));
            System.out.println("sign=" + sign);
            params.put("signValue", sign);
            json = JSONObject.fromObject(params);

        } catch (Exception e) {
            e.printStackTrace();
        }
        String url = URL + "/changeMerAccInfo";
        String result = HttpClientUtil.sendJson(url, json);
        //	String result = Https.httpsSend(url, params, 10000, 10000);
        System.out.println(result);
    }

    // 保存图片
    @Test
    public void savePicTest() throws Exception {
        File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
        String privateKeyPassword = "123456";
        String sign = "";
        try {
            HashMap<String, String> param = new HashMap<String, String>();
            File file = new File("E:\\pay\\1.jpg");
            param.put("picType", "B008");
            param.put("sysFlowId", String.valueOf(new Date().getTime()));
            param.put("accOrg", "ORG20191114174409");
            param.put("changeFlowId", "20210925143144560671651145081");

            sign = GenerateSignUtil.generateSign(param, privateKeyFile,
                    privateKeyPassword);
            param.put("signValue", sign);
            String url = URL + "/changeMerPic";
            String result = HttpClientUtil.sendHttpMessage(url, param, file,
                    "file");
            System.out.println("======"+result);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    @Test
    public void changeMerOnlineFee() throws Exception {
        File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
        String privateKeyPassword = "123456";
        Map<String, Object> map = new HashMap<String, Object>();
        JSONObject obj1 = new JSONObject();
        obj1.put("mercId","826440357229AVA");//826440357229AV8
        JSONObject obj = new JSONObject();
        //添加费率信息
        //一档：贷记卡费率
        obj.put("creditRate", "0.8");//0.8
        //一档：贷记卡封底
        obj.put("creditMin", "100.00");//100.00
        //一档：借记卡费率
        obj.put("debitRate", "0.8");
        //一档：借记卡封底.
        obj.put("debitMin", "100.00");
        //一档：借记卡封顶
        obj.put("debitMax", "9998");
        obj1.put("bankFee1",obj);

        JSONObject obj2 = new JSONObject();
        //二档：贷记卡费率
        obj2.put("creditRate", "0.3");//0.3
        //二档：贷记卡封底
        obj2.put("creditMin", "100.00");//100.00
        //二档：借记卡费率
        obj2.put("debitRate", "0.3");
        //二档：借记卡封底.
        obj2.put("debitMin", "100.00");
        //二档：借记卡封顶
        obj2.put("debitMax", "9998");
        obj1.put("bankFee2",obj2);

        JSONObject obj3 = new JSONObject();
        obj3.put("wechatSignRate", "0.51");//0.51
        obj3.put("wechatSignMin", "100.00");
        obj3.put("alipaySignMin", "100.00");
        obj3.put("alipaySignRate", "0.5");
        obj1.put("wxAliFee",obj3);


        String data = JSONArray.toJSONString(obj1);
        System.out.println("data==" + data);
        String key = "A81F41DE7406CC1566579A751D93CA7A";
        String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
        System.out.println(creData);
        String sign = "";
        net.sf.json.JSONObject json = null;
        Map<String, String> params = new HashMap<String, String>();
        try {
            params.put("ver", "1.0");
            params.put("msgCode", "Merchant");
            params.put("method", "changeMerOnlineFee");
            params.put("src", "ORG20191114174409");
            params.put("signType", "RSA");
            params.put("charset", "UTF-8");
            params.put("data", creData);
            sign = GenerateSignUtil.generateSign(params, privateKeyFile,
                    privateKeyPassword);
            params.put("reqFlowId", String.valueOf(new Date().getTime()));
            System.out.println("sign=" + sign);
            params.put("signValue", sign);
            json = net.sf.json.JSONObject.fromObject(params);

        } catch (Exception e) {
            e.printStackTrace();
        }
        String url = URL + "/changeMerOnlineFee";
        String result = HttpClientUtil.sendJson(url, json);
        //String result = Https.httpsSend(url, params, 10000, 10000);
        System.out.println(result);
    }

    @Test
    public void changeMerPosFee() throws Exception {
        File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
        String privateKeyPassword = "123456";
        Map<String, Object> map = new HashMap<String, Object>();
        JSONObject obj1 = new JSONObject();
        obj1.put("mercId","826440357229AV8");
        JSONObject obj = new JSONObject();
        //添加费率信息
        //工作日到账-借记卡费率
        obj.put("t111Rate", "0.8");
        //工作日到账-借记卡费率封顶
        obj.put("t111RateTop", "999800");
        //工作日到账-借记卡费率封底
        obj.put("t111SignRateMin", "100.80");
        //工作日到账-贷记卡费率
        obj.put("t112Rate", "0.8");
        //工作日到账-贷记卡费率封底
        obj.put("t112SignRateMin", "100.00");
        obj1.put("posT1AcctFee",obj);

        String data = JSONArray.toJSONString(obj1);
        System.out.println("data==" + data);
        String key = "A81F41DE7406CC1566579A751D93CA7A";
        String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
        System.out.println(creData);
        String sign = "";
        net.sf.json.JSONObject json = null;
        Map<String, String> params = new HashMap<String, String>();
        try {
            params.put("ver", "1.0");
            params.put("msgCode", "Merchant");
            params.put("method", "changeMerPosFee");
            params.put("src", "ORG20191114174409");
            params.put("signType", "RSA");
            params.put("charset", "UTF-8");
            params.put("data", creData);
            sign = GenerateSignUtil.generateSign(params, privateKeyFile,
                    privateKeyPassword);
            params.put("reqFlowId", String.valueOf(new Date().getTime()));
            System.out.println("sign=" + sign);
            params.put("signValue", sign);
            json = net.sf.json.JSONObject.fromObject(params);

        } catch (Exception e) {
            e.printStackTrace();
        }
        String url = URL + "/changeMerPosFee";
        String result = HttpClientUtil.sendJson(url, json);
        //String result = Https.httpsSend(url, params, 10000, 10000);
        System.out.println(result);
    }
}
