package com.yspay.demo.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yspay.demo.DesUtil;
import com.yspay.demo.GenerateSignUtil;
import com.yspay.demo.HttpClientUtil;
import org.junit.Test;

import java.io.File;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author caobing
 * @version 1.0
 * @date 2021/9/14 10:17
 */
public class OrgOnlineTradingPermissionDemoTest {

    private static String URL = "http://orgmerc.ysepay.com:8880/saas/orgScan"; //测试环境

    //private static String URL = "http://localhost:7100/saas/orgScan"; //本地环境

    @Test
    public void onlineTradingPermission() throws Exception {
        File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
        String privateKeyPassword = "123456";
        Map<String, Object> map = new HashMap<String, Object>();
        JSONObject obj1 = new JSONObject();
        //位数为1为开通 第1位微信小程序支付 第2位微信公众号支付(新)
        // 第3位微信反扫 第4位支付宝正扫 第5位支付宝反扫
        // 第6位支付宝服务商 第7位银联正扫 第8位银联反扫 第9位行业码
        //开通权限 多个用,隔开
        obj1.put("scanServiceOpen","1,2,3,4,5,6,7,8,9");
        obj1.put("mercId","826741057228062");
        //接入机构号
        obj1.put("accOrgNo","ORG20191114174409");
        JSONObject obj = new JSONObject();
        //添加费率信息
        //obj.put("rscanTempMark", "1231");
        //obj.put("rscanFeeTemplateNo", "123123");
        //反扫微信费类型(1百分比 2固定金额)
        obj.put("rscanWxFeeType", "1");
        //反扫微信费率% （例如0.3表示%0.3）
        obj.put("rscanWxFeeRate", "0.3");
        //反扫微信金额（百分比时候为封底金额  固定金额时为固定金额）
        obj.put("rscanWxFeeNum", "1.00");
        //反扫支付宝费类型(1百分比 2固定金额)
        obj.put("rscanAliFeeType", "1");
        //反扫支付宝费率
        obj.put("rscanAliFeeRate", "0.4");
        //反扫支付宝金额（百分比时候为封底金额  固定金额时为固定金额）
        obj.put("rscanAliFeeNum", "2.00");

        //反扫银联借记卡一档费率类型(1百分比 2固定金额)
        obj.put("rscanDebitType1", "1");
        //反扫银联借记卡一档金额（固定金额时为固定金额）
        obj.put("rscanDebitNum1", "0.5");
        //反扫银联借记卡一档金额（百分比时为封底金额）
        obj.put("rscanDebitMin1", "1.00");
        //反扫银联借记卡一档金额（百分比时为封顶金额）
        obj.put("rscanDebitMax1", "99999999.00");

        //反扫银联借记卡二档费率类型(1百分比 2固定金额)
        obj.put("rscanDebitType2", "1");
        //反扫银联借记卡二档金额（固定金额时为固定金额）
        obj.put("rscanDebitNum2", "0.26");
        //反扫银联借记卡二档金额（百分比时为封底金额）
        obj.put("rscanDebitMin2", "0.1");
        //反扫银联借记卡二档金额（百分比时为封顶金额）
        obj.put("rscanDebitMax2", "999");

        //反扫银联贷记卡一档费率类型(1百分比 2固定金额)
        obj.put("rscanCreditType1", "1");
        //反扫银联贷记卡一档金额（固定金额时为固定金额）
        obj.put("rscanCreditNum1", "0.53");
        //反扫银联贷记卡一档金额（百分比时为封底金额）
        obj.put("rscanCreditMin1", "2.00");

        //反扫银联贷记卡二档费类型(1百分比 2固定金额)
        obj.put("rscanCreditType2", "1");
        //反扫银联贷记卡二档金额（固定金额时为固定金额）
        obj.put("rscanCreditNum2", "0.25");
        //反扫银联贷记卡二档金额（百分比时为封底金额）
        obj.put("rscanCreditMin2", "0.1");


        //obj.put("d0TempMark", "");
        //obj.put("d0FeeTemplateNo", "");
        //obj.put("d0Type", "");
        //obj.put("d0Rate", "");
        //obj.put("d0Num", "");
        obj1.put("easyFeeBean",obj);

        String data = JSONArray.toJSONString(obj1);
        System.out.println("data==" + data);
        String key = "A81F41DE7406CC1566579A751D93CA7A";
        String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
        System.out.println(creData);
        String sign = "";
        net.sf.json.JSONObject json = null;
        Map<String, String> params = new HashMap<String, String>();
        try {
            params.put("ver", "1.0");
            params.put("msgCode", "Merchant");
            params.put("method", "onlineTrading");
            params.put("src", "ORG20191114174409");
            params.put("signType", "RSA");
            params.put("charset", "UTF-8");
            params.put("data", creData);
            sign = GenerateSignUtil.generateSign(params, privateKeyFile,
                    privateKeyPassword);
            params.put("reqFlowId", String.valueOf(new Date().getTime()));
            System.out.println("sign=" + sign);
            params.put("signValue", sign);
            json = net.sf.json.JSONObject.fromObject(params);

        } catch (Exception e) {
            e.printStackTrace();
        }
        String url = URL + "/onlineTrading";
        String result = HttpClientUtil.sendJson(url, json);
        //String result = Https.httpsSend(url, params, 10000, 10000);
        System.out.println(result);
    }
}
