package com.yspay.demo.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yspay.demo.DesUtil;
import com.yspay.demo.GenerateSignUtil;
import com.yspay.demo.HttpClientUtil;
import org.junit.Test;

import java.io.File;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author caobing
 * @version 1.0
 * @date 2021/9/14 10:17
 */
public class ScanOptOnlineTest {

    //private static String URL = "https://ouser.ysepay.com:6443/saas/orgScan";   //正式环境
    //private static String URL = "http://orgmerc.ysepay.com:8880/saas/orgScan"; //测试环境
    //private static String URL = "https://bcs.ysepay.com/saas/orgScan";  //灰度环境
    private static String URL = "http://localhost:7100/saas/orgScan"; //本地环境

    @Test
    public void optOnlineD0() throws Exception {
        File privateKeyFile = new File("E:\\workspace\\yulong_666.pfx");
        String privateKeyPassword = "123456";
        Map<String, Object> map = new HashMap<String, Object>();
        JSONObject obj = new JSONObject();
        obj.put("mercId","826440357229AWE");
        //权限操作类型：1开通 0关闭
        obj.put("opType","1");
        //费率（单位：1%）
        obj.put("feeRate","0.03");
        //封底（单位：分）
        obj.put("feeMin","2");
        String data = JSONArray.toJSONString(obj);
        System.out.println("data==" + data);
        String key = "A81F41DE7406CC1566579A751D93CA7A";
        String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
        System.out.println(creData);
        String sign = "";
        net.sf.json.JSONObject json = null;
        Map<String, String> params = new HashMap<String, String>();
        try {
            params.put("ver", "1.0");
            params.put("msgCode", "Merchant");
            params.put("method", "optOnlineD0");
            params.put("src", "ORG20191114174409");
            params.put("signType", "RSA");
            params.put("charset", "UTF-8");
            params.put("data", creData);
            sign = GenerateSignUtil.generateSign(params, privateKeyFile,
                    privateKeyPassword);
            params.put("reqFlowId", String.valueOf(new Date().getTime()));
            System.out.println("sign=" + sign);
            params.put("signValue", sign);
            json = net.sf.json.JSONObject.fromObject(params);

        } catch (Exception e) {
            e.printStackTrace();
        }
        String url = URL + "/optOnlineD0";
        String result = HttpClientUtil.sendJson(url, json);
        //String result = Https.httpsSend(url, params, 10000, 10000);
        System.out.println(result);
    }
}
