package com.yspay.demo.service;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import org.junit.Test;

import com.yspay.demo.DesUtil;
import com.yspay.demo.GenerateSignUtil;
import com.yspay.demo.HttpClientUtil;

import net.sf.json.JSONObject;

public class SignContractDemo {
	private static String URL = "https://ouser.ysepay.com:6443/saas/orgSign";
	//private static String URL = "http://orgmerc.ysepay.com:8880/saas/orgSign";  //826电子合同
	//private static String URL = "http://localhost:7100/saas/orgSign";
	//private static String URL = "https://bcs.ysepay.com/saas/orgSign";
	//private static String URL = "http://orgmerc.ysepay.com:8880/saas/orgQry";  //QRY电子合同
	@Test
	public void sendSmsCode() throws Exception {
		File privateKeyFile = new File("E:\\pay\\testkey.pfx");
		String privateKeyPassword = "test1234";
		Map<String, String> map = new HashMap<String, String>();
		map.put("sysFlowId","27202108181509034762875");
		map.put("isSendMsg","Y");
		String data = JSONObject.fromObject(map).toString();
		System.out.println("data==" + data);
		String key = "A81F41DE7406CC1566579A751D93CA7A";
		String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
		System.out.println(creData);
		Map<String, String> params = new HashMap<String, String>();
		try {
			params.put("ver", "1.0");
			params.put("msgCode", "Merchant");
			params.put("method", "sendSmsCode");
			params.put("src", "ORG20200827095703");
			params.put("signType", "RSA");
			params.put("charset", "UTF-8");
			params.put("data", creData);
		

			String sign = GenerateSignUtil.generateSign(params, privateKeyFile,
					privateKeyPassword);
			System.out.println("sign=" + sign);
			params.put("signValue", sign);
			JSONObject json = JSONObject.fromObject(params);
			String url = URL + "/sendSmsCode";
			String result = HttpClientUtil.sendJson(url, json);
			System.out.println(result);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	@Test
	public void querySignSts() throws Exception {
//		File privateKeyFile = new File("D:\\Users\\huapf\\tms\\demo\\src\\java\\resources\\conf\\yulong_666.pfx");
//		String privateKeyPassword = "123456";
		File privateKeyFile = new File("E:\\pay\\testkey.pfx");
		String privateKeyPassword = "test1234";
		Map<String, String> map = new HashMap<String, String>();
		map.put("sysSignFlowId","MAN202103033234210");
		String data = JSONObject.fromObject(map).toString();
		System.out.println("data==" + data);
		String key = "A81F41DE7406CC1566579A751D93CA7A";
		String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
		System.out.println(creData);
		Map<String, String> params = new HashMap<String, String>();
		try {
			params.put("ver", "1.0");
			params.put("msgCode", "Merchant");
			params.put("method", "querySignSts");
			params.put("src", "ORG20200827095703");
			params.put("signType", "RSA");
			params.put("charset", "UTF-8");
			params.put("data", creData);

			String sign = GenerateSignUtil.generateSign(params, privateKeyFile,
					privateKeyPassword);
			System.out.println("sign=" + sign);
			params.put("signValue", sign);
			JSONObject json = JSONObject.fromObject(params);
			String url = URL + "/querySignSts";
			String result = HttpClientUtil.sendJson(url, json);
		//	String result =Https.httpsSend(url, params, 3000, 3000);
			System.out.println(result);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	@Test
	public void invalidSign() throws Exception {
		File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
		String privateKeyPassword = "123456";
		Map<String, String> map = new HashMap<String, String>();
		map.put("sysSignFlowId","MAN202011170121106");
		String data = JSONObject.fromObject(map).toString();
		System.out.println("data==" + data);
		String key = "A81F41DE7406CC1566579A751D93CA7A";
		String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
		System.out.println(creData);
		Map<String, String> params = new HashMap<String, String>();
		try {
			params.put("ver", "1.0");
			params.put("msgCode", "Merchant");
			params.put("method", "querySignSts");
			params.put("src", "ORG20191114174409");
			params.put("signType", "RSA");
			params.put("charset", "UTF-8");
			params.put("data", creData);

			String sign = GenerateSignUtil.generateSign(params, privateKeyFile,
					privateKeyPassword);
			System.out.println("sign=" + sign);
			params.put("signValue", sign);
			JSONObject json = JSONObject.fromObject(params);
			String url = URL + "/invalidSign";
			String result = HttpClientUtil.sendJson(url, json);
			System.out.println(result);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	@Test
	public void downSign() throws Exception {
		File privateKeyFile = new File("E:\\pay\\yulong_666.pfx");
		String privateKeyPassword = "123456";
		Map<String, String> map = new HashMap<String, String>();
		map.put("sysSignFlowId","MAN202011170121106");
		String data = JSONObject.fromObject(map).toString();
		System.out.println("data==" + data);
		String key = "A81F41DE7406CC1566579A751D93CA7A";
		String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
		System.out.println(creData);
		Map<String, String> params = new HashMap<String, String>();
		try {
			params.put("ver", "1.0");
			params.put("msgCode", "Merchant");
			params.put("method", "querySignSts");
			params.put("src", "ORG20191114174409");
			params.put("signType", "RSA");
			params.put("charset", "UTF-8");
			params.put("data", creData);

			String sign = GenerateSignUtil.generateSign(params, privateKeyFile,
					privateKeyPassword);
			System.out.println("sign=" + sign);
			params.put("signValue", sign);
			JSONObject json = JSONObject.fromObject(params);
			String url = URL + "/downSign";
			String result = HttpClientUtil.sendJson(url, json);
			System.out.println(result);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}


	@Test
	public void sendScanSmsCode() throws Exception {
		File privateKeyFile = new File("E:\\pay\\testkey.pfx");
		String privateKeyPassword = "test1234";
		Map<String, String> map = new HashMap<String, String>();
		map.put("sysFlowId","27202108181509034762875");
		map.put("mercClass","Term");//终端Term 立牌Qry
		map.put("isSendMsg","Y");
		String data = JSONObject.fromObject(map).toString();
		System.out.println("data==" + data);
		String key = "A81F41DE7406CC1566579A751D93CA7A";
		String creData = DesUtil.encryptExtraData(key, "UTF-8", data);
		System.out.println(creData);
		Map<String, String> params = new HashMap<String, String>();
		try {
			params.put("ver", "1.0");
			params.put("msgCode", "Merchant");
			params.put("method", "sendScanSmsCode");
			params.put("src", "ORG20200827095703");
			params.put("signType", "RSA");
			params.put("charset", "UTF-8");
			params.put("data", creData);


			String sign = GenerateSignUtil.generateSign(params, privateKeyFile,
					privateKeyPassword);
			System.out.println("sign=" + sign);
			params.put("signValue", sign);
			JSONObject json = JSONObject.fromObject(params);
			String url = URL + "/sendSmsCode";
			String result = HttpClientUtil.sendJson(url, json);
			System.out.println(result);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
