package com.yspay.demo.transfer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yspay.demo.HttpClientUtil;
import org.apache.commons.lang.StringUtils;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 *
 */
public class ActPayTransferDemo {

    private String BASE_URL = "http://multi-gate-api-server-fat.yspos-fat.com/multi-gate-api";

    @Test
    public void actPayMercAccess() {
        String custId="2021032905743457";
        String mercId = "826673057228025";
        TbsOnlineUserFlumeLimit limit = new TbsOnlineUserFlumeLimit();
        limit.setDayPennumber("2000");
        limit.setDayAmt("5000000");
        limit.setMonthPennumbr("20000");
        limit.setMonthAmt("50000000");
        limit.setEachAmt("8000");
        limit.setEachAmtMin("0.01");
        JSONObject param = ActPayService.utilOnlineActPayMerc(mercId,limit);
        String httpUrl = BASE_URL + "/report/cust/dsfProtocol/add/1.0.0";
        System.out.println("调用渠道 企业代收付入网新增接口" + httpUrl + "/r/n 入参：" + param.toJSONString());
        String rsp = HttpClientUtil.sendJson(httpUrl, JSONObject.parseObject(JSONArray.toJSONString(param)));
        System.out.println("调用渠道 企业代收付入网新增出参：" + rsp);
    }


    @Test
    public void addRoute() {
        String custId="2021032905743457";
        String mercId = "826440357229AU1";
        JSONObject param = new JSONObject();
        String timeStamp = BcsUtils.getTimestampStr(new Date());
        param.put("tradeSource","44");                //类型：String  必有字段  备注：交易来源 请联系本项目组获取
        param.put("reqMsgId",timeStamp);                //类型：String  必有字段  备注：请求流水号
        param.put("charset","UTF-8");                //类型：String  必有字段  备注：字符集
        param.put("timestamp",timeStamp);               //类型：String  必有字段  备注：时间戳
        param.put("srcUserCode",mercId);              //类型：String  必有字段  备注：发起方用户号（长度：<3，20>）
        param.put("tradeType",RouteTemplete.DDL.tradeType);               //类型：String  必有字段  备注：交易类型 101 代收加急 102 代付加急 104 网联支付退款 等等
        param.put("routerTemplateno",RouteTemplete.DDL.routerTemplateno);              //类型：String  必有字段  备注：路由模版编号 pj_template01 pj_实时代收付模板 等等，路由模板编号是根据新增模板定义来确定
        String httpUrl = BASE_URL + "/report/merchant/route/add/1.0.0";
        System.out.println("调用渠道 路由新增接口" + httpUrl + "/r/n 入参：" + param.toJSONString());
        String rsp = HttpClientUtil.sendJson(httpUrl, JSONObject.parseObject(JSONArray.toJSONString(param)));
        System.out.println("调用渠道 路由新增出参：" + rsp);
    }
}
