package com.yspay.demo.transfer;

import java.util.ArrayList;
import java.util.List;

/**
 * 扫码线下费率服务
 */
public class ScanUnlineFeeService {


    /**
     * 扫码业务微信费率修改参数封装
     */
    public static List<UrmtmfeeBaseParam> codeBusinessWxParams(WxAliFeeVO wxAliFee) {
        List<UrmtmfeeBaseParam> urmtmfeeBaseParamList = new ArrayList<UrmtmfeeBaseParam>();
        // ===================计费信息参数--扫码业务微信签约费率===================//
        UrmtmfeeBaseParam bean = new UrmtmfeeBaseParam();
        bean.setModifyRemark("扫码业务微信签约费率");
        bean.setRateType("S");// S 签约费率 、 C-结算费率
        bean.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean.setFeeCalMth("2");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写)
        // bean.setChengben("1");// 0-手动设置、1-默认成本、2-按银盛商户类型
        bean.setUserAccountType("**");// 00-借记卡 01-贷记卡 **-全部卡类型
        bean.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean.setBusiType("05");// 01-订单支付 04-收单消费05-微信支付
        bean.setBusiCode("00590004");// 业务代码--微信
        bean.setPayMode("21");// 支付方式 21-POSP线下支付
        bean.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean.setUserCardOrg("00");// 卡组织 00-银联
        bean.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        List<UrmtmfeeInfoParam> urmtmfeeInfoList = new ArrayList<UrmtmfeeInfoParam>();
        UrmtmfeeInfoParam info = new UrmtmfeeInfoParam();
        info.setMinFeeAmt(wxAliFee.getWechatSignMin());// 封底金额,最低金额
        info.setMaxFeeAmt(wxAliFee.getWechatSignMax());// 封顶金额,最高金额?表里面存的是封顶费率
        info.setFeeRat1(wxAliFee.getWechatSignRate());// 费率
        // info.setFixFeeAmt("50");//固定金额
        urmtmfeeInfoList.add(info);

        bean.setUrmtmfeeInfoList(urmtmfeeInfoList);
        // 添加第一条费率：扫码业务-签约费率-微信

        urmtmfeeBaseParamList.add(bean);

        UrmtmfeeBaseParam bean11 = new UrmtmfeeBaseParam();
        bean11.setModifyRemark("扫码业务微信结算费率");
        bean11.setRateType("C");// S 签约费率 、 C-结算费率
        bean11.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean11.setFeeCalMth("2");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写)

        bean11.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型


        bean11.setUserAccountType("**");// 00-借记卡 01-贷记卡 **-全部卡类型
        bean11.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean11.setBusiType("05");// 01-订单支付 04-收单消费05-微信支付
        bean11.setBusiCode("00590004");// 业务代码--微信
        bean11.setPayMode("21");// 支付方式 21-POSP线下支付
        bean11.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean11.setUserCardOrg("00");// 卡组织 00-银联
        bean11.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean11.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        List<UrmtmfeeInfoParam> urmtmfeeInfoList11 = new ArrayList<UrmtmfeeInfoParam>();
        UrmtmfeeInfoParam info11 = new UrmtmfeeInfoParam();
        info11.setMinFeeAmt(wxAliFee.getWechatSignMin());// 封底金额,最低金额
        info11.setMaxFeeAmt(wxAliFee.getWechatSignMax());// 封顶金额,最高金额?表里面存的是封顶费率
        info11.setFeeRat1(wxAliFee.getWechatSignRate());// 费率

        // info11.setFixFeeAmt("50");//固定金额
        urmtmfeeInfoList11.add(info11);

        //对应的垫资费//

        bean11.setUrmtmfeeInfoList(urmtmfeeInfoList11);

        // 添加第二条费率：扫码业务-签约费率-微信
        urmtmfeeBaseParamList.add(bean11);

        return urmtmfeeBaseParamList;
    }

    /**
     * 扫码业务支付宝费率修改参数封装
     */
    public static List<UrmtmfeeBaseParam> codeBusinessZfbParams(WxAliFeeVO wxAliFee) {
        List<UrmtmfeeBaseParam> urmtmfeeBaseParamList = new ArrayList<UrmtmfeeBaseParam>();
        // ===================计费信息参数--扫码业务支付宝签约费率===================//
        UrmtmfeeBaseParam bean2 = new UrmtmfeeBaseParam();
        bean2.setModifyRemark("扫码业务支付宝签约费率");
        bean2.setRateType("S");// S 签约费率 、 C-结算费率
        bean2.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean2.setFeeCalMth("2");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写)
//		bean2.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        bean2.setUserAccountType("**");// 00-借记卡 01-贷记卡 **-全部卡类型
        bean2.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean2.setBusiType("06");// 01-订单支付 04-收单消费06支付宝支付
        bean2.setBusiCode("00690004");// 业务代码--支付宝
        bean2.setPayMode("21");// 支付方式 21-POSP线下支付
        bean2.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean2.setUserCardOrg("00");// 卡组织 00-银联
        bean2.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean2.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        List<UrmtmfeeInfoParam> urmtmfeeInfoList_06_1 = new ArrayList<UrmtmfeeInfoParam>();
        UrmtmfeeInfoParam info2 = new UrmtmfeeInfoParam();
        info2.setMinFeeAmt(wxAliFee.getAlipaySignMin());// 封底金额,最低金额
        info2.setMaxFeeAmt(wxAliFee.getAlipaySignMax());// 封顶金额,最高金额
        // info2.setFixFeeAmt("500");// 固定金额
        info2.setFeeRat1(wxAliFee.getAlipaySignRate());// 费率
        urmtmfeeInfoList_06_1.add(info2);

        //对应的垫资费//

        bean2.setUrmtmfeeInfoList(urmtmfeeInfoList_06_1);
        // 添加第一条费率：扫码业务-签约费率-支付宝
        urmtmfeeBaseParamList.add(bean2);

        UrmtmfeeBaseParam bean21 = new UrmtmfeeBaseParam();
        bean21.setModifyRemark("扫码业务支付宝结算费率");
        bean21.setRateType("C");// S 签约费率 、 C-结算费率
        bean21.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean21.setFeeCalMth("2");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写)

        bean21.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型


        bean21.setUserAccountType("**");// 00-借记卡 01-贷记卡 **-全部卡类型
        bean21.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean21.setBusiType("06");// 01-订单支付 04-收单消费06支付宝支付
        bean21.setBusiCode("00690004");// 业务代码--支付宝
        bean21.setPayMode("21");// 支付方式 21-POSP线下支付
        bean21.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean21.setUserCardOrg("00");// 卡组织 00-银联
        bean21.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean21.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        List<UrmtmfeeInfoParam> urmtmfeeInfoList_06_2 = new ArrayList<UrmtmfeeInfoParam>();
        UrmtmfeeInfoParam info21 = new UrmtmfeeInfoParam();
        info21.setMinFeeAmt(wxAliFee.getAlipaySignMin());// 封底金额,最低金额
        info21.setMaxFeeAmt(wxAliFee.getAlipaySignMax());// 封顶金额,最高金额
        // info2.setFixFeeAmt("500");// 固定金额
        info21.setFeeRat1(wxAliFee.getAlipaySignRate());// 费率
        urmtmfeeInfoList_06_2.add(info21);

        //对应的垫资费//

        bean21.setUrmtmfeeInfoList(urmtmfeeInfoList_06_2);
        // 添加第一条费率：扫码业务-签约费率-支付宝
        urmtmfeeBaseParamList.add(bean21);

        return urmtmfeeBaseParamList;
    }


    /**
     * 扫码业务银联费率修改参数封装
     */
    public static List<UrmtmfeeBaseParam> codeBusinessBankFee(BankFeeVO bankFee1, BankFeeVO bankFee2){

        List<UrmtmfeeBaseParam> urmtmfeeBaseParamList = new ArrayList<UrmtmfeeBaseParam>();
        //获取银联费率

        UrmtmfeeBaseParam bean = new UrmtmfeeBaseParam();
        bean.setModifyRemark("扫码业务扫银联签约费率");
        bean.setRateType("S");// S 签约费率 、 C-结算费率
        bean.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean.setFeeCalMth("3");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写) 3-分层套档
        bean.setUserAccountType("00");// 00-借记卡 01-贷记卡 **-全部卡类型
        // bean.setChengben("1");// 0-手动设置、1-默认成本、2-按银盛商户类型
        bean.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean.setBusiType("08");// 01-订单支付 04-收单消费05-微信支付 08-银联二维码
        bean.setBusiCode("00490004");// 业务代码--微信  2050009-银联二维码   消费  00490004 update 20200628
        bean.setPayMode("21");// 支付方式 21-POSP线下支付
        bean.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean.setUserCardOrg("00");// 卡组织 00-银联
        bean.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        List<UrmtmfeeInfoParam> urmtmfeeInfoList = new ArrayList<UrmtmfeeInfoParam>();
        UrmtmfeeInfoParam info1 = new UrmtmfeeInfoParam();
        info1.setBegAmt("1000.01");
        info1.setEndAmt("9999999.99");
        info1.setFeeCalMth("2");
        info1.setMinFeeAmt(bankFee1.getDebitMin());// 封底金额,最低金额
        info1.setMaxFeeAmt(bankFee1.getDebitMax());// 封顶金额,最高金额?表里面存的是封顶费率
        info1.setFeeRat1(bankFee1.getDebitRate());// 费率
        urmtmfeeInfoList.add(info1);

        UrmtmfeeInfoParam info2 = new UrmtmfeeInfoParam();
        info2.setBegAmt("0");
        info2.setEndAmt("1000");
        info2.setFeeCalMth("2");
        info2.setMinFeeAmt(bankFee2.getDebitMin());// 封底金额,最低金额
        info2.setMaxFeeAmt(bankFee2.getDebitMax());// 封顶金额,最高金额?表里面存的是封顶费率
        info2.setFeeRat1(bankFee2.getDebitRate());// 费率
        urmtmfeeInfoList.add(info2);



        bean.setUrmtmfeeInfoList(urmtmfeeInfoList);
        urmtmfeeBaseParamList.add(bean);

        //结算费率  结算费率没有的话做一下兼容
        UrmtmfeeBaseParam bean6 = new UrmtmfeeBaseParam();
        bean6.setModifyRemark("扫码业务扫银联结算费率");
        bean6.setRateType("C");// S 签约费率 、 C-结算费率
        bean6.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean6.setFeeCalMth("3");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写) 3-分层套档
        bean6.setUserAccountType("00");// 00-借记卡 01-贷记卡 **-全部卡类型
        bean6.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean6.setBusiType("08");// 01-订单支付 04-收单消费05-微信支付 08-银联二维码
        bean6.setBusiCode("00490004");// 业务代码--微信  2050009-银联二维码   消费  00490004 update 20200628
        bean6.setPayMode("21");// 支付方式 21-POSP线下支付
        bean6.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean6.setUserCardOrg("00");// 卡组织 00-银联
        bean6.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean6.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        bean6.setUrmtmfeeInfoList(urmtmfeeInfoList);
        urmtmfeeBaseParamList.add(bean6);



        UrmtmfeeBaseParam bean1 = new UrmtmfeeBaseParam();
        bean1.setRateType("S");// S 签约费率 、 C-结算费率
        bean1.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean1.setFeeCalMth("3");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写) 3-分层套档
        bean1.setUserAccountType("01");// 00-借记卡 01-贷记卡 **-全部卡类型
        // bean.setChengben("1");// 0-手动设置、1-默认成本、2-按银盛商户类型
        bean1.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean1.setBusiType("08");// 01-订单支付 04-收单消费05-微信支付 08-银联二维码
        bean1.setBusiCode("00490004");// 业务代码--微信  2050009-银联二维码 消费  00490004 update 20200628
        bean1.setPayMode("21");// 支付方式 21-POSP线下支付
        bean1.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean1.setUserCardOrg("00");// 卡组织 00-银联
        bean1.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean1.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        bean1.setUrmtmfeeInfoList(urmtmfeeInfoList);
        urmtmfeeBaseParamList.add(bean1);

        //结算费率  结算费率没有的话做一下兼容
        UrmtmfeeBaseParam bean7 = new UrmtmfeeBaseParam();
        bean7.setRateType("C");// S 签约费率 、 C-结算费率
        bean7.setMercFeeMod("1");// 1-实时单笔收取、2- 线下月结、0-不收取
        bean7.setFeeCalMth("3");// 计费方式 1-固定金额 2-按百分比 6-双重计费(D0时填写) 3-分层套档
        bean7.setUserAccountType("01");// 00-借记卡 01-贷记卡 **-全部卡类型
        bean7.setIsSiWuRu("Y");// 小数计费规则 Y-四舍五入计、N-进位取整
        bean7.setBusiType("08");// 01-订单支付 04-收单消费05-微信支付 08-银联二维码
        bean7.setBusiCode("00490004");// 业务代码--微信  2050009-银联二维码 消费  00490004 update 20200628
        bean7.setPayMode("21");// 支付方式 21-POSP线下支付
        bean7.setStandardChecked("0");// 费率分类 0-标准费率、3-非标准费率
        bean7.setUserCardOrg("00");// 卡组织 00-银联
        bean7.setAreaFlag("0");// 卡片所属地 0-境内卡
        bean7.setChengben("0");// 0-手动设置、1-默认成本、2-按银盛商户类型
        bean7.setUrmtmfeeInfoList(urmtmfeeInfoList);
        urmtmfeeBaseParamList.add(bean7);

        return urmtmfeeBaseParamList;
    }

}
