package com.yspay.demo.transfer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yspay.demo.HttpClientUtil;
import org.apache.commons.lang.StringUtils;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 *
 */
public class TransferDemo {

    private String BASE_URL = "http://multi-gate-api-server-fat.yspos-fat.com/multi-gate-api";

    @Test
    public void updateScanOnlineFeeInfo() {
        String mercId="2021032905743457";
        JSONObject updateScanObj = ScanOnlineFeeService.initUpdateFeeParam(mercId);
        JSONArray updateList = new JSONArray();
        WxAliFeeVO wxAliFeeVO = new WxAliFeeVO();
        wxAliFeeVO.setWechatSignRate("25");
        wxAliFeeVO.setWechatSignMin("2");
        wxAliFeeVO.setAlipaySignMin("6");
        wxAliFeeVO.setAlipaySignRate("23");
        //修改内容包含微信费率信息
        if(StringUtils.isNotBlank(wxAliFeeVO.getWechatSignRate())
                || StringUtils.isNotBlank(wxAliFeeVO.getWechatSignMin())){
            updateList.addAll(ScanOnlineFeeService.initWxUpdateParam(wxAliFeeVO));
        }
        //修改内容包含修改支付宝费率信息
        if(StringUtils.isNotBlank(wxAliFeeVO.getAlipaySignRate())
                || StringUtils.isNotBlank(wxAliFeeVO.getAlipaySignRate())){
            updateList.addAll(ScanOnlineFeeService.initZfbUpdateParam(wxAliFeeVO));
        }

        BankFeeVO bankFee1 = new BankFeeVO();
        bankFee1.setCreditRate("22");
        bankFee1.setDebitRate("20");
        BankFeeVO bankFee2 = new BankFeeVO();
        bankFee2.setCreditRate("21");
        bankFee2.setDebitRate("18");
        updateList.addAll(ScanOnlineFeeService.initBankUpdateParam(bankFee1,bankFee2));

        updateScanObj.put("feeRuleDefinitions",updateList);
        String httpUrl = BASE_URL + "/report/order/feeRule/update/1.0.0";
        System.out.println("调用渠道 商户计费模板信息修改入参：" + updateScanObj.toJSONString());
        String rsp = HttpClientUtil.sendJson(httpUrl, updateScanObj);
        System.out.println("调用渠道 商户计费模板信息修改出参：" + rsp);
        JSONObject obj = JSONObject.parseObject(rsp);
        if("00".equals(obj.getString("state"))){
            String auditUrl = BASE_URL + "/report/order/feeRule/audit/1.0.0";
            Map<String, Object> bandingAudit = ScanOnlineFeeService.utilBandingAudit("test", mercId);
            System.out.println(mercId+"审核绑定计费模板参数" + JSON.toJSONString(bandingAudit));
            String bandingAuditResult = HttpClientUtil.sendJson(auditUrl, JSONObject.parseObject(JSON.toJSONString(bandingAudit)));
            System.out.println(mercId+"审核绑定计费模板结果" + JSON.toJSONString(bandingAuditResult));
            JSONObject bandingAuditResultObject = JSONObject.parseObject(bandingAuditResult);
        }



    }


    @Test
    public void updateScanUnlineFeeInfo() {

        WxAliFeeVO wxAliFeeVO = new WxAliFeeVO();
        wxAliFeeVO.setWechatSignRate("25");
        wxAliFeeVO.setWechatSignMin("2");
        wxAliFeeVO.setAlipaySignMin("6");
        wxAliFeeVO.setAlipaySignRate("23");
        BankFeeVO bankFee1 = new BankFeeVO();
        bankFee1.setCreditRate("22");
        bankFee1.setDebitRate("20");
        BankFeeVO bankFee2 = new BankFeeVO();
        bankFee2.setCreditRate("21");
        bankFee2.setDebitRate("18");
        // 需要修改的费率总集合
        List<UrmtmfeeBaseParam> urmtmfeeBaseParamList = new ArrayList<UrmtmfeeBaseParam>();


        //修改内容包含微信费率信息
        if(StringUtils.isNotBlank(wxAliFeeVO.getWechatSignRate())
                || StringUtils.isNotBlank(wxAliFeeVO.getWechatSignMin())){
            urmtmfeeBaseParamList.addAll(ScanUnlineFeeService.codeBusinessWxParams(wxAliFeeVO));
        }
        //修改内容包含修改支付宝费率信息
        if(StringUtils.isNotBlank(wxAliFeeVO.getAlipaySignRate())
                || StringUtils.isNotBlank(wxAliFeeVO.getAlipaySignMin())){
            urmtmfeeBaseParamList.addAll(ScanUnlineFeeService.codeBusinessZfbParams(wxAliFeeVO));
        }


        urmtmfeeBaseParamList.addAll(ScanUnlineFeeService.codeBusinessBankFee(bankFee1,bankFee2));


        //扫码垫资费
        //urmtmfeeBaseParamList.addAll(scanUnlineFeeService.codeBusinessAdvance(flume));


        //String custId="2021032905743457";
        String mercId="826673057228025";
        String coOperatorNo ="801711088885730";
        //同步POSP费率
        for(UrmtmfeeBaseParam param : urmtmfeeBaseParamList){

            param.setTradeSource("44");
            param.setCharset("UTF-8");
            param.setReqMsgId(BcsUtils.getTimestampStr(new Date()));
            param.setTimestamp(param.getReqMsgId());
            param.setMercId(mercId);
            param.setAgentMercId(coOperatorNo);
            String httpUrl = BASE_URL + "/report/posp/fee/update/1.0.0";
            System.out.println("调用渠道 更新POSP费率入参：" + JSON.toJSONString(param));
            String rsp = HttpClientUtil.sendJson(httpUrl, JSONObject.parseObject(JSONArray.toJSONString(param)));
            System.out.println("调用渠道 更新POSP费率出参：" + rsp);
            JSONObject objRsp = JSONObject.parseObject(rsp);
        }
    }
}
